<template>
  <div
    class="sidebar"
    :data-color="activeColor"
    :data-background-color="backgroundColor"
    :style="sidebarStyle"
  >
    <div class="logo">
      <a href="/console/" class="simple-text logo-mini">
        <div class="logo-img">
          <img v-bind:src="jollygoodplus_symbol_logo" />
        </div>
      </a>
      <a href="/console/" class="simple-text logo-normal">
        <template>{{ $t('mypage') }}</template>
      </a>
      <div class="navbar-minimize">
        <md-button
          id="minimizeSidebar"
          class="md-round md-just-icon md-transparent"
          @click="minimizeSidebar"
        >
          <i class="material-icons text_align-center visible-on-sidebar-regular"
            >more_vert</i
          >
          <i
            class="material-icons design_bullet-list-67 visible-on-sidebar-mini"
            >view_list</i
          >
        </md-button>
      </div>
    </div>
    <div class="sidebar-wrapper" ref="sidebarScrollArea">
      <slot></slot>
      <md-list class="nav">
        <slot name="links">
          <sidebar-item
            v-for="(link, index) in sidebarLinks"
            :key="link.name + index"
            :link="link"
          >
            <sidebar-item
              v-for="(subLink, index) in link.children"
              :key="subLink.name + index"
              :link="subLink"
            >
            </sidebar-item>
          </sidebar-item>
        </slot>
      </md-list>

      <ul class="md-list nav md-theme-default">
        <li tag="li" class="">
          <a href="/accounts/sign_out" class="nav-link" target="_self">
            <img v-bind:src="icon_logout()" class="custom-icon" />
            <p>{{ $t('sign_out') }}</p>
          </a>
        </li>
      </ul>
    </div>
  </div>
</template>
<script>
import jollygoodplus_symbol_logo from '/src/assets/images/jollygoodplus_symbol_logo.png';
import icon_logout from '/src/assets/images/icon_logout.png';
export default {
  name: 'sidebar',
  props: {
    activeColor: {
      type: String,
      default: 'green',
      validator: (value) => {
        let acceptedValues = [
          '',
          'primary',
          'azure',
          'green',
          'orange',
          'danger',
          'rose',
        ];
        return acceptedValues.indexOf(value) !== -1;
      },
    },
    backgroundColor: {
      type: String,
      default: 'black',
      validator: (value) => {
        let acceptedValues = ['', 'black', 'white', 'red'];
        return acceptedValues.indexOf(value) !== -1;
      },
    },
    sidebarLinks: {
      type: Array,
      default: () => [],
    },
    autoClose: {
      type: Boolean,
      default: true,
    },
    contactUsQuery: {
      type: String,
      default: '',
    },
  },
  mounted() {
    this.$sidebar.load_cookie();
  },
  provide() {
    return {
      autoClose: this.autoClose,
    };
  },
  methods: {
    icon_logout() {
      return icon_logout;
    },
    minimizeSidebar() {
      if (this.$sidebar) {
        this.$sidebar.toggleMinimize();
      }
    },
  },
  computed: {
    jollygoodplus_symbol_logo() {
      return jollygoodplus_symbol_logo;
    },

    sidebarStyle() {
      return {};
    },
  },
  beforeDestroy() {
    if (this.$sidebar.showSidebar) {
      this.$sidebar.showSidebar = false;
    }
  },
};
</script>
<style scoped>
@media (min-width: 992px) {
  .navbar-search-form-mobile,
  .nav-mobile-menu {
    display: none;
  }
}

.simple-text {
  text-transform: none !important;
}

.sidebar .logo .simple-text .logo-img img {
  width: 100%;
}

.logo {
  padding: 20px 0 !important;
}

.logo-mini {
  padding: 0 !important;
}

.logo-normal {
  height: 30px !important;
  font-size: 14px !important;
  vertical-align: middle !important;
  padding: 0 !important;
}

.logo-img {
  background: none !important;
  border-radius: 0% !important;
}

.custom-icon {
  float: left;
  margin-right: 15px !important;
  margin-left: 0;
  line-height: 30px;
  width: 30px;
  height: 30px;
  opacity: 0.8;
}

.sidebar-wrapper {
  overflow-y: scroll;
  -ms-overflow-style: none; /* IE, Edge 対応 */
  scrollbar-width: none; /* Firefox 対応 */
}

.sidebar-wrapper::-webkit-scrollbar {
  display: none; /* Chrome, Safari 対応 */
}

a.nav-link:hover {
  opacity: 100;
}
</style>
